import threading
import time
import main_program
from ev3_queue import ev3_queue as Queue
#from video_thread import video_thread
global thread
class touch:
    
    def __init__(self, port):
        global thread
        self.__thread=thread
        self.__number=thread.add_sensor(port,"touch")
    def is_pressed(self):
        self.__thread.update_sensors()
        return self.__thread.get_sensor_value(self.__number)
    
class program_thread(threading.Thread):

    def __init__(self,send_queue,receive_queue,kill_event,start_program_event,ip_adress_queue):
        global thread
        thread=self
        self.__receive_queue = receive_queue
        self.__send_queue = send_queue
        self.__sensors=[]
        self.__number_of_sensors=0
        self.__kill_event=kill_event
        self.__start_program_event=start_program_event
        self.__video_thread=None
        self.__queue_video=None
        self.__ip_adress_queue=ip_adress_queue
        self.__video_stream_enabled=False
        threading.Thread.__init__(self)
    def start_stream(self):
        if not self.__video_stream_enabled:
            self.queue_put(["command",["start_stream",("",)]])
            self.__queue_video=Queue()
            self.__show_video_event=threading.Event()
            self.__enable_faces_event=threading.Event()
            self.__enable_movements_event=threading.Event()
            self.__video_thread=video_thread(self.__queue_video,self.__show_video_event,self.__enable_faces_event,self.__enable_movements_event,self.__ip_adress_queue)
            self.__video_thread.daemon=True
            self.__video_thread.start()
            self.__video_stream_enabled=True
    def show_video(self):
        self.__show_video_event.set()
    def disable_video(self):
        self.__show_video_event.clear()
    def enable_faces(self):
        self.__enable_faces_event.set()
    def disable_faces(self):
        self.__enable_faces_event.clear()
    def enable_movements(self):
        self.__enable_movements_event.set()
    def disable_movements(self):
        self.__enable_movements_event.clear()
    def queue_put(self,command):
        self.wait_for_queue(self.__send_queue)
        list_of_queue_object=[]
        while not self.__send_queue.empty():
            item=self.__send_queue.get()
            if item==command:
                pass
            else:
                list_of_queue_object.append(item)
        for element in list_of_queue_object:
            self.__send_queue.put(element)
        self.__send_queue.put(command)
        self.reset_queue(self.__send_queue)
    def run_old(self):
        main_program.main(self)
    def run(self):
        while True:
            print("waiting")
            self.__start_program_event.wait()
            self.__start_program_event.clear()
            import main_program
            main_program=reload(main_program)
            main_program.main(self)
            self.queue_put(["restart_program"])
            self.__sensors=[]
            self.__number_of_sensors=0
            
    def shutdown(self):
        print("program thread shuting down")
        self.queue_put(["shutdown"])
        time.sleep(5)
        self.__kill_event.set()
    def restart(self):
        print("program thread restarting")
        self.queue_put(["restart"])
    def add_sensor(self,port,type):
        self.__sensors.append([port,type,"update"])
        self.queue_put(["add_sensor",[port,type,self.__number_of_sensors]])
        self.__number_of_sensors=self.__number_of_sensors+1
        return self.__number_of_sensors-1
    def get_sensor_value(self,sensor_number):
        value=self.__sensors[sensor_number][2]
        while value=="update":
            self.update_sensors()
            value=self.__sensors[sensor_number][2]
        return self.__sensors[sensor_number][2]
    def handle_incoming_data(self,item):
        if item[0]=="sensor_values":
            for i in range(self.__number_of_sensors):
                try:
                    self.__sensors[i][2]=item[1][i]
                except IndexError:
                    pass
            
        if item[0]=="kill_connection":
            self.__kill_event.set()
        time.sleep(0.01)
    def read_incoming(self):
        self.wait_for_queue(self.__receive_queue)
        while not self.__receive_queue.empty():
            item=self.__receive_queue.get()
            self.handle_incoming_data(item)
        self.reset_queue(self.__receive_queue)
    def update_sensors(self):
        self.read_incoming()
    def wait_for_queue(self,queue):
        while queue.get_wanna():
            pass
        queue.set_wanna()
        while queue.get_read():
            pass
        queue.set_read()
        queue.reset_wanna()
        pass
    def reset_queue(self,queue):
        queue.reset_read()
    """------------------------------API for USER----------------------------------------------------"""
    #return battery voltage
    def get_battery(self):
        self.update_sensors()
        return self.get_sensor_value(self.__battery)
    
    def is_up_button_pressed(self):
        self.update_sensors()
        return self.get_sensor_value(self.__UP_BUTTON)


    def is_down_button_pressed(self):
        self.update_sensors()
        return self.get_sensor_value(self.__DOWN_BUTTON)


    def is_left_button_pressed(self):
        self.update_sensors()
        return self.get_sensor_value(self.__LEFT_BUTTON)


    def is_right_button_pressed(self):
        self.update_sensors()
        return self.get_sensor_value(self.__RIGHT_BUTTON)


    def is_enter_button_pressed(self):
        self.update_sensors()
        return self.get_sensor_value(self.__ENTER_BUTTON)
    
    def is_back_button_pressed(self):
        self.update_sensors()
        return self.get_sensor_value(self.__BACK_BUTTON)
    """Set LED light on EV3 brick.

    Args:
       light (int):  LED to turn on.

    *light* values:
        - LED_BLACK
        - LED_GREEN
        - LED_RED
        - LED_ORANGE
        - LED_GREEN_FLASH
        - LED_RED_FLASH
        - LED_ORANGE_FLASH
        - LED_GREEN_PULSE
        - LED_RED_PULSE
        - LED_ORANGE_PULSE

    """
    def set_led(self,light):
        self.queue_put(["command",["set_led",("",light)]])
    def play_tone(frequency, duration, volume=100):
        self.queue_put(["command",["play_tone",("frequency",frequency),("duration",duration),("volume",volume)]])