import threading
import numpy as np
import cv2
import time
import pygame
import cv2.cv as cv
import os
face_cascade = cv2.CascadeClassifier('/usr/share/opencv/haarcascades/haarcascade_frontalface_default.xml')
eye_cascade = cv2.CascadeClassifier('/usr/share/opencv/haarcascades/haarcascade_eye.xml')

class video_thread(threading.Thread):

    def __init__(self,frame_queue,show_video_event,faces_event,movement_event,ip_adress_queue):
        self.__ip_adress_queue=ip_adress_queue
        self.__ip_adress=self.__ip_adress_queue.get()
        self.__ip_adress_queue.put(self.__ip_adress)
        self.__frame_queue=frame_queue
        self.__show_video_event=show_video_event
        self.__faces_event=faces_event
        self.__movement_event=movement_event
        time.sleep(5)
        self.__cam_stream_adress="tcp://"+self.__ip_adress+":5000?resolution=800x600.mjpg"
        self.__cap=cv2.VideoCapture(self.__cam_stream_adress)
        threading.Thread.__init__(self)
    def run(self):
        number=0
        face_rectangles=[]
        eyes_rectangles=[]
        while True:
            waste=self.__cap.retrieve()
            ret, frame = self.__cap.read()
            if self.__faces_event.is_set() and number==15:
                rec=faces_function(frame)
                face_rectangles=rec[0]
                eyes_rectangles=rec[1]
                number=0
            for rectangle in face_rectangles:
                cv2.rectangle(frame,rectangle[0],rectangle[1],(255,0,0),2)
            for rectangle in eyes_rectangles:
                cv2.rectangle(frame,rectangle[0],rectangle[1],(0,255,0),2)
            if self.__show_video_event.is_set():
                cv2.imshow('frame',frame)
                cv2.waitKey(1)
            number+=1
def faces_function(img):
    gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
    faces = face_cascade.detectMultiScale(gray, 1.3, 5)
    faces_rectangle=[]
    eyes_rectangle=[]
    for (x,y,w,h) in faces:
        #print("face")
        #print(x,y,w,h)
        #cv2.rectangle(img,(x,y),(x+w,y+h),(255,0,0),2)
        faces_rectangle.append([(x,y),(x+w,y+h)])
        roi_gray = gray[y:y+h, x:x+w]
        #roi_color = img[y:y+h, x:x+w]
        eyes = eye_cascade.detectMultiScale(roi_gray)
        for (ex,ey,ew,eh) in eyes:
            #cv2.rectangle(roi_color,(ex,ey),(ex+ew,ey+eh),(0,255,0),2)
            eyes_rectangle.append([(x+ex,y+ey),(x+ex+ew,y+ey+eh)])
               
    return [faces_rectangle,eyes_rectangle]
    